<?
use \Bitrix\Main\Loader,
	\Bitrix\Highloadblock\HighloadBlockTable as HLB,
	\Bitrix\Highloadblock\HighloadBlockLangTable;

if(Loader::includeModule('sale'))
{
	$eventManager = \Bitrix\Main\EventManager::getInstance();
	$eventManager->addEventHandlerCompatible("sale", "OnCondSaleActionsControlBuildList", [
			"SaleActionDiscountFromDirectory",
			"GetControlDescr"
		]);

	class SaleActionDiscountFromDirectory extends \CSaleActionCtrlBasketGroup
	{
		public static function GetClassName()
		{
			return __CLASS__;
		}

		public static function GetControlID()
		{
			return "DiscountFromDirectory";
		}

		public static function GetControlDescr()
		{
			return parent::GetControlDescr();
		}

		public static function GetAtoms()
		{
			return static::GetAtomsEx(false, false);
		}

		public static function GetControlShow($arParams)
		{
			$arAtoms = static::GetAtomsEx(false, false);
			$arResult = [
				"controlId" => static::GetControlID(),
				"group" => false,
				"label" => "Применить скидку из справочника",
				"defaultText" => "",
				"showIn" => static::GetShowIn($arParams["SHOW_IN_GROUPS"]),
				"control" => [
					"Применить скидку из HighLoad блока",
					$arAtoms["HLB"]
				]
			];

			return $arResult;
		}

		public static function GetAtomsEx($strControlID = false, $boolEx = false)
		{
			$boolEx = (true === $boolEx ? true : false);
			$hlbList = [];
			if (\Bitrix\Main\Loader::includeModule('highloadblock'))
			{
				$dbRes = HLB::GetList([]);
				while ($el = $dbRes->fetch())
				{
					$hlbList[$el['ID']] = $el['NAME'];
				}
				$res = HighloadBlockLangTable::GetList(['filter' => ['=LID' => LANGUAGE_ID]]);
				while ($el = $res->fetch())
				{
					if ($hlbList[$el['ID']])
						$hlbList[$el['ID']] = $el['NAME'] . " [" . $hlbList[$el['ID']] . "]";
				}
			}
			$arAtomList = [
				"HLB" => [
					"JS" => [
						"id" => "HLB",
						"name" => "extra",
						"type" => "select",
						"values" => $hlbList,
						"defaultText" => "...",
						"defaultValue" => "",
						"first_option" => "..."
					],
					"ATOM" => [
						"ID" => "HLB",
						"FIELD_TYPE" => "string",
						"FIELD_LENGTH" => 255,
						"MULTIPLE" => "N",
						"VALIDATE" => "list"
					]
				],
			];
			if (!$boolEx)
			{
				foreach ($arAtomList as &$arOneAtom)
				{
					$arOneAtom = $arOneAtom["JS"];
				}
				if (isset($arOneAtom))
				{
					unset($arOneAtom);
				}
			}
			return $arAtomList;
		}

		public static function Generate($arOneCondition, $arParams, $arControl, $arSubs = false)
		{
			$mxResult = __CLASS__ . "::applyProductDiscount(" . $arParams["ORDER"] . ", " . "\"" . $arOneCondition["HLB"] . "\"" . ");";

			return $mxResult;
		}

		/**
		 * Применяет скидку из справочника к товарам из корзины
		 * @param $arOrder
		 * @param $hlb - Highload block
		 */
		public static function applyProductDiscount(&$arOrder, $hlb)
		{
			$userId = $arOrder['USER_ID'];
			if ($userId && \Bitrix\Main\Loader::includeModule('highloadblock'))
			{
				$productIds = [];
				foreach ($arOrder['BASKET_ITEMS'] as &$product)
				{
					$productIds[] = $product['PRODUCT_ID'];
				}
				unset($product);
				$hlblock = HLB::getById($hlb)->fetch();
				if(!$hlblock)
				{
					return;
				}
				$entity = HLB::compileEntity($hlblock);
				$entityClass = $entity->getDataClass();
				//Находим записи в справочнике с нужными параметрами - товар/пользователь
				$dbRes = $entityClass::getList([
						'filter' => [
							'=UF_PRODUCT' => $productIds,
							'=UF_USER' => $userId
						],
						'order' => [
							'ID' => 'DESC'
						]
					]);
				$discounts = [];
				while ($el = $dbRes->fetch())
				{
					if (!$discounts[$el['UF_PRODUCT']])
					{
						$discounts[$el['UF_PRODUCT']] = $el;
					}
				}
				//Применяем скидку
				foreach ($arOrder['BASKET_ITEMS'] as &$product)
				{
					$productId = $product['PRODUCT_ID'];
					if ($discounts[$productId])
					{
						$product['DISCOUNT_PRICE'] = $product['BASE_PRICE'] * $discounts[$productId]['UF_DISCOUNT'] / 100;
						$product['PRICE'] = $product['BASE_PRICE'] - $product['DISCOUNT_PRICE'];
					}
				}
				unset($product);
			}
		}
	}
}